static DH *get_dh512(void)
{
    static unsigned char dhp_512[] = {
        0x85, 0x09, 0x29, 0xE6, 0x15, 0x80, 0x04, 0x8E, 0x24, 0x40,
        0xDE, 0x82, 0x09, 0x3C, 0xAA, 0x5B, 0xED, 0x5E, 0x60, 0xF9,
        0x12, 0x95, 0x36, 0x02, 0x47, 0x4D, 0x7D, 0x1C, 0xC8, 0x97,
        0xB6, 0x77, 0x6F, 0x58, 0x15, 0xA5, 0xAA, 0xF5, 0x3B, 0xA5,
        0x12, 0x28, 0x03, 0x1C, 0x8B, 0x26, 0x1C, 0xB9, 0x54, 0xA1,
        0x13, 0x14, 0xA6, 0x07, 0x12, 0xC4, 0xBA, 0x44, 0xDC, 0x52,
        0x67, 0x32, 0x95, 0xDB
    };
    static unsigned char dhg_512[] = {
        0x05
    };
    DH *dh = DH_new();
    BIGNUM *p, *g;

    if (dh == NULL)
        return NULL;
    p = BN_bin2bn(dhp_512, sizeof(dhp_512), NULL);
    g = BN_bin2bn(dhg_512, sizeof(dhg_512), NULL);
    if (p == NULL || g == NULL
            || !DH_set0_pqg(dh, p, NULL, g)) {
        DH_free(dh);
        BN_free(p);
        BN_free(g);
        return NULL;
    }
    return dh;
}
